--//
--// Core NDCH script
--//

local key = '324fsijn34';	--// Set this as a unique key

-------------- 

local ulogger = {};

local logdb = nil;

function onLoad()
	logdb = SQLiteDatabase('ulog.db');

	if logdb.tableExists('iplog') == false then
		logdb.execSQL('CREATE TABLE iplog ("ip" INTEGER NOT NULL PRIMARY KEY, "nick" TEXT, "seencount" INTEGER, "lastupdate" DATETIME);');
	end;

	if logdb.tableExists('nicklog') == false then
		logdb.execSQL('CREATE TABLE nicklog ("nick" TEXT NOT NULL PRIMARY KEY, "ip" INTEGER, "seencount" INTEGER, "inbuf" INTEGER, "outbuf" INTEGER, "lastupdate" DATETIME);');
	end;
end;

updateTables = function()
	--[[local rows = logdb.openSQL('SELECT ip FROM iplog WHERE ip = '..user.ip..';');
	if rows.count == 0 then
		logdb.execSQL('INSERT INTO iplog (ip, nick, seencount, lastupdate) VALUES('..user.ip..', "'..user.nick..'", 1, NOW());');
	else
		logdb.execSQL('UPDATE iplog SET nick="'..user.nick..'", seencount=seencount+'..', lastupdate=NOW() WHERE ip = '..user.ip..';');
	end;]]
end;

function onUserConnected(user)
 
	--[[if ulogger[user.ip] then
		ulogger[user.ip] = {
			["nick"] = user.nick, 
			["seencount"] = ulogger[user.ip]["seencount"] + 1,
			["lastupdate"] = 0,
		}

	else
		ulogger[user.ip] = {
			["ip"] = user.ip,
			["nick"] = user.nick, 
			["seencount"] = 1,
			["lastupdate"] = 0,
		}
	end;

	--if #ulogger > 5 then
		updateTables(); --// do this every 5 mins ?
	--end;]]

	local rows = logdb.openSQL('SELECT ip FROM iplog WHERE ip = '..user.ip..';');
	if rows.count == 0 then
		logdb.execSQL('INSERT INTO iplog (ip, nick, seencount, lastupdate) VALUES('..user.ip..', "'..user.nick..'", 1, datetime("now"));');
	else
		logdb.execSQL('UPDATE iplog SET nick="'..user.nick..'", seencount=seencount+1, lastupdate=datetime("now") WHERE ip = '..user.ip..';');
	end;
	rows = nil;

	rows = logdb.openSQL('SELECT nick FROM nicklog WHERE nick = "'..user.nick..'";');
	if rows.count == 0 then
		logdb.execSQL('INSERT INTO nicklog (nick, ip, seencount, lastupdate) VALUES("'..user.nick..'", '..user.ip..', 1, datetime("now"));');
	else
		logdb.execSQL('UPDATE nicklog SET ip='..user.ip..', seencount=seencount+1, lastupdate=datetime("now") WHERE nick = "'..user.nick..'";');
	end;
end;

getHelp = function(user)
	local s = "\n\tBasics\n\n";

	s = s.."!me						- Write in third person\n";
	s = s.."!myip						- Display your IP4 address\n";

	return s;
end;

getAbout = function()
	return "NDCH script by Meka][Meka. Feel free to use as a base template.";
end;

function onTextCommand(user, cmd, text);
	--// some additional simple commands not implemented directly into hub software

	if cmd == "!myip" then
		Hub.SendToUser(user, '<'..Hub.BotName..'> Your IP: '..user.ipstr);
		return true;
	elseif cmd == '!me' then
		Hub.SendToAll('** '..user.nick..' '..text);
		return true;

	--elseif cmd == '!luaversion' then
	--	Hub.SendToUser(user, '<'..Hub.BotName..'> Hub is running '.._VERSION);
	--	return true;

	elseif cmd == '!nickinfo' then
		local permissions = user.getPermissions();
	
		if permissions.whois == true then
			local s = 'Information for nickname: "'..text..'"\n\n\t';

			local row = logdb.openSQL('SELECT nick,ip,seencount,lastupdate FROM nicklog WHERE nick = "'..text..'" COLLATE NOCASE;');
			if row.EOF == false then
				local nick, ip, seencount, lastupdate = row.Expand();
				s = s .. "This user last logged in with ip "..ho2ip(ip).." ["..ho2cc(ip).."] at "..lastupdate.." and has been seen "..seencount.." time(s), this ip has been used with the following nicknames:\n\n\t";

				local row = logdb.openSQL('SELECT ip,nick,seencount,lastupdate FROM iplog WHERE ip = '..ip..';');
				while row.EOF == false do
					local ip, nick, seencount, lastupdate = row.Expand();

					s = s .. nick..', seen '..seencount..' time(s), last used at '..lastupdate.."\n\t";

					row.Next();
				end;	
			end;

			s = s .. "\n\tThis nickname has used the following ip(s):\n\n\t";

			local row = logdb.openSQL('SELECT ip,nick,seencount,lastupdate FROM iplog WHERE nick = "'..text..'" COLLATE NOCASE;');
			while row.EOF == false do
				local ip, nick, seencount, lastupdate = row.Expand();

				s = s .. ho2ip(ip)..', seen '..seencount..' time(s), last logged in at '..lastupdate.."\n\t";

				row.Next();
			end;	

			Hub.SendToUser(user, Hub.BotName, s);
		else
			Hub.SendToUser(user, '<'..Hub.BotName..'> You do not have permission to use this command!');
		end;

		return true;

	--[[elseif cmd == '!viewdb' then
		-- updateTables

		local row = logdb.openSQL('SELECT * FROM iplog;');
		while row.EOF == false do
			local ip, nick, seencount, lastupdate = row.Expand();

			Hub.SendToAll(Hub.BotName, ip..', '..nick..', '..seencount..', '..lastupdate);

			row.Next();
		end;	

		local row = logdb.openSQL('SELECT nick,ip,seencount,lastupdate FROM nicklog;');
		while row.EOF == false do
			local nick, ip, seencount, lastupdate = row.Expand();

			Hub.SendToAll(Hub.BotName, nick..', '..ho2ip(ip)..', '..seencount..', '..lastupdate);

			row.Next();
		end;	

		return true;]]--
	end;
end;
